package javaMM.launch;

import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.util.EObjectValidator;
import java.util.Map;
import org.eclipse.ocl.standalone.*;
import javaMM.JavaMMPackage;
import javaMM.util.JavaMMValidator;

public class JavaMMLauncher {
	public static void main(String[] args) {
		
		if (args.length == 0 || args[0].length() < 5)
			throw new IllegalArgumentException("Must provide absolute path to EMF model!");
		
		new StandaloneOCL(StandaloneOCL.newCompiledInstance(JavaMMPackage.eINSTANCE, JavaMMValidator.INSTANCE, args)) {
			@Override
			protected ConstraintDiagnostician createDiagnostician(Resource modelImpl) {
				return new ConstraintDiagnostician(modelImpl, false) {
					
					@Override
					public boolean validate(EClass eClass, EObject eObject, DiagnosticChain diagnostics, Map<Object, Object> context) {
					    boolean result = validator.validate(eClass, eObject, diagnostics, context);
					    if ((result || diagnostics != null) && context.get(EObjectValidator.ROOT_OBJECT) != eObject) {
					    	result &= doValidateContents(eObject, diagnostics, context);
					    }
					    return result;
					}
					
				};
			}
		}
		.run();
	}
}
